# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::Kusto::Mgmt::V2018_09_07_privatepreview
  module Models
    #
    # Class representing an event hub connection validation.
    #
    class EventHubConnectionValidation

      include MsRestAzure

      # @return [String] The name of the event hub connection.
      attr_accessor :eventhub_connection_name

      # @return [String] The resource ID of the event hub to be used to create
      # a data connection.
      attr_accessor :event_hub_resource_id

      # @return [String] The event hub consumer group.
      attr_accessor :consumer_group

      # @return [String] The table where the data should be ingested.
      # Optionally the table information can be added to each message.
      attr_accessor :table_name

      # @return [String] The mapping rule to be used to ingest the data.
      # Optionally the mapping information can be added to each message.
      attr_accessor :mapping_rule_name

      # @return [DataFormat] The data format of the message. Optionally the
      # data format can be added to each message. Possible values include:
      # 'MULTIJSON', 'JSON', 'CSV'
      attr_accessor :data_format


      #
      # Mapper for EventHubConnectionValidation class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'EventHubConnectionValidation',
          type: {
            name: 'Composite',
            class_name: 'EventHubConnectionValidation',
            model_properties: {
              eventhub_connection_name: {
                client_side_validation: true,
                required: false,
                serialized_name: 'eventhubConnectionName',
                type: {
                  name: 'String'
                }
              },
              event_hub_resource_id: {
                client_side_validation: true,
                required: true,
                serialized_name: 'properties.eventHubResourceId',
                type: {
                  name: 'String'
                }
              },
              consumer_group: {
                client_side_validation: true,
                required: true,
                serialized_name: 'properties.consumerGroup',
                type: {
                  name: 'String'
                }
              },
              table_name: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.tableName',
                type: {
                  name: 'String'
                }
              },
              mapping_rule_name: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.mappingRuleName',
                type: {
                  name: 'String'
                }
              },
              data_format: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.dataFormat',
                type: {
                  name: 'String'
                }
              }
            }
          }
        }
      end
    end
  end
end
