# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::Kusto::Mgmt::V2018_09_07_preview
  module Models
    #
    # Class representing a Kusto database.
    #
    class Database < TrackedResource

      include MsRestAzure

      # @return [String] An ETag of the resource created.
      attr_accessor :etag

      # @return [ProvisioningState] The provisioned state of the resource.
      # Possible values include: 'Running', 'Creating', 'Deleting',
      # 'Succeeded', 'Failed'
      attr_accessor :provisioning_state

      # @return [Integer] The number of days data should be kept before it
      # stops being accessible to queries.
      attr_accessor :soft_delete_period_in_days

      # @return [Integer] The number of days of data that should be kept in
      # cache for fast queries.
      attr_accessor :hot_cache_period_in_days

      # @return [DatabaseStatistics] The statistics of the database.
      attr_accessor :statistics


      #
      # Mapper for Database class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'Database',
          type: {
            name: 'Composite',
            class_name: 'Database',
            model_properties: {
              id: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'id',
                type: {
                  name: 'String'
                }
              },
              name: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'name',
                type: {
                  name: 'String'
                }
              },
              type: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'type',
                type: {
                  name: 'String'
                }
              },
              tags: {
                client_side_validation: true,
                required: false,
                serialized_name: 'tags',
                type: {
                  name: 'Dictionary',
                  value: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'StringElementType',
                      type: {
                        name: 'String'
                      }
                  }
                }
              },
              location: {
                client_side_validation: true,
                required: true,
                serialized_name: 'location',
                type: {
                  name: 'String'
                }
              },
              etag: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'etag',
                type: {
                  name: 'String'
                }
              },
              provisioning_state: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'properties.provisioningState',
                type: {
                  name: 'String'
                }
              },
              soft_delete_period_in_days: {
                client_side_validation: true,
                required: true,
                serialized_name: 'properties.softDeletePeriodInDays',
                type: {
                  name: 'Number'
                }
              },
              hot_cache_period_in_days: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.hotCachePeriodInDays',
                type: {
                  name: 'Number'
                }
              },
              statistics: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.statistics',
                type: {
                  name: 'Composite',
                  class_name: 'DatabaseStatistics'
                }
              }
            }
          }
        }
      end
    end
  end
end
